#ifndef POLYNOMIAL_MESH_BUILDER_HPP
#define POLYNOMIAL_MESH_BUILDER_HPP

#include <mesh/MeshTraits.hpp>

class MeshVariant;

#include <memory>

class PolynomialMeshBuilder
{
 protected:
  std::shared_ptr<const MeshVariant> m_mesh;

  template <MeshConcept MeshType>
  void _build(const MeshType& mesh, const uint64_t& degree);

 public:
  std::shared_ptr<const MeshVariant>
  mesh() const
  {
    return m_mesh;
  }

  PolynomialMeshBuilder(const std::shared_ptr<const MeshVariant>& mesh_v, const uint64_t& degree);
  ~PolynomialMeshBuilder() = default;
};

#endif   // POLYNOMIAL_MESH_BUILDER_HPP
